﻿package{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	// Classes used in this example
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import Keys;
	public class HelloWorld extends Sprite{
	
		
		
		public function HelloWorld(){
			//keyboard input
			Keys.initialize(stage);
			
			
			
			// Add event for main loop
			addEventListener(Event.ENTER_FRAME, Update, false, 0, true);
			
			
			
			// Creat world AABB
			var worldAABB:b2AABB = new b2AABB();
			worldAABB.lowerBound.Set(-100.0, -100.0);
			worldAABB.upperBound.Set(100.0, 100.0);
			
			// Define the gravity vector
			var gravity:b2Vec2 = new b2Vec2(0.0, 0.0);
			
			// Allow bodies to sleep
			var doSleep:Boolean = true;
			
			// Construct a world object
			m_world = new b2World(worldAABB, gravity, doSleep);
			
			// set debug draw
			/*var dbgDraw:b2DebugDraw = new b2DebugDraw();
			var dbgSprite:Sprite = new Sprite();
			addChild(dbgSprite);
			dbgDraw.m_sprite = dbgSprite;
			dbgDraw.m_drawScale = 30.0;
			dbgDraw.m_fillAlpha = 0.0;
			dbgDraw.m_lineThickness = 1.0;
			dbgDraw.m_drawFlags = 0xFFFFFFFF;
			m_world.SetDebugDraw(dbgDraw);*/
			
			
			
			// Vars used to create bodies
			var body:b2Body;
			var bodyDef:b2BodyDef;
			var boxDef:b2PolygonDef;
			var circleDef:b2CircleDef;
			
			
			
			// Add ground body
			/*bodyDef = new b2BodyDef();
			//bodyDef.position.Set(15, 19);
			bodyDef.position.Set(10, 12);
			//bodyDef.angle = 0.1;
			boxDef = new b2PolygonDef();
			boxDef.SetAsBox(30, 3);
			boxDef.friction = 0.3;
			boxDef.density = 0; // static bodies require zero density
			/*circleDef = new b2CircleDef();
			circleDef.radius = 10;
			circleDef.restitution = 0.2
			// Add sprite to body userData
			bodyDef.userData = new PhysGround();
			//bodyDef.userData = new PhysCircle();
			bodyDef.userData.width = 30 * 2 * 30; 
			bodyDef.userData.height = 30 * 2 * 3; 
			addChild(bodyDef.userData);
			body = m_world.CreateBody(bodyDef);
			body.CreateShape(boxDef);
			//body.CreateShape(circleDef);
			body.SetMassFromShapes();*/
			
			// Add some objects
			for (var i:int = 1; i < 10; i++){
				bodyDef = new b2BodyDef();
				bodyDef.position.x = Math.random() * 15 + 5;
				bodyDef.position.y = Math.random() * 10;
				/*bodyDef.position.x = stage.width/2;
				bodyDef.position.y = stage.height/2;*/
				//var rX:Number = Math.random() + 0.5;
				var rX:Number = .5;
				var rY:Number = Math.random() + 0.5;
				// Box
				/*if (Math.random() < 0.5){
					boxDef = new b2PolygonDef();
					boxDef.SetAsBox(rX, rY);
					boxDef.density = 1.0;
					boxDef.friction = 0.5;
					boxDef.restitution = 0.2;
					bodyDef.userData = new PhysBox();
					bodyDef.userData.width = rX * 2 * 30; 
					bodyDef.userData.height = rY * 2 * 30; 
					body = m_world.CreateBody(bodyDef);
					body.CreateShape(boxDef);
				} */
				// Circle
				//else {
					circleDef = new b2CircleDef();
					circleDef.radius = rX;
					circleDef.density = 1.0;
					circleDef.friction = 0.5;
					circleDef.restitution = 0.2;
					bodyDef.userData = new PhysCircle();
					bodyDef.userData.width = rX * 2 * 30; 
					bodyDef.userData.height = rX * 2 * 30; 
					body = m_world.CreateBody(bodyDef);
					body.CreateShape(circleDef);
			//	}
				body.SetMassFromShapes();
				addChild(bodyDef.userData);
			}
			
			//interactivity
			//body.ApplyImpulse(new b2Vec2(0.5, 0.5), new b2Vec2(0.5, 0.5));
			//body.ApplyForce(new b2Vec2(0.5, 0.5), new b2Vec2(0.5, 0.5));
		/*	var fX:Number = new Number();
			var fY:Number = new Number();
			if (Keys.isDown( Keyboard.DOWN )){
				fX = 0;
				fY = 1;
				body.ApplyForce(new b2Vec2(fX, fY), new b2Vec2( fX, fY));
				trace("applyForce");
			} else if (Keys.isDown( Keyboard.UP)){
				fX = 0;
				fY = -1;
				body.ApplyForce(new b2Vec2(fX, fY), new b2Vec2( fX, fY));
				trace("applyForce");
			} else if (Keys.isDown( Keyboard.LEFT )){
				fX = -1;
				fY = 0;
				body.ApplyForce(new b2Vec2(fX, fY), new b2Vec2( fX, fY));
				trace("applyForce");
			} else if (Keys.isDown( Keyboard.RIGHT)){
				fX = 1;
				fY = 0;
				body.ApplyForce(new b2Vec2(fX, fY), new b2Vec2( fX, fY));
				trace("applyForce");
			}*/
			stage.addEventListener(MouseEvent.CLICK, ripple);
		}
		
		public function ripple(e:Event) {
			m_world.Step(m_timeStep, m_iterations);
			var fX:Number = 1;
			var fY:Number = 1;
			// Go through body list and update sprite positions/rotations
			for (var bb:b2Body = m_world.m_bodyList; bb; bb = bb.m_next){
				if (bb.m_userData is Sprite){
					bb.ApplyForce(new b2Vec2(bb.m_userData.x - stage.mouseX,  bb.m_userData.y - stage.mouseY), new b2Vec2( bb.m_userData.x, bb.m_userData.y));
				}
			}
		}
		
		public function Update(e:Event):void{
			
			m_world.Step(m_timeStep, m_iterations);
			
			// Go through body list and update sprite positions/rotations
			for (var bb:b2Body = m_world.m_bodyList; bb; bb = bb.m_next){
				if (bb.m_userData is Sprite){
					bb.m_userData.x = bb.GetPosition().x * 30;
					bb.m_userData.y = bb.GetPosition().y * 30;
					bb.m_userData.rotation = bb.GetAngle() * (180/Math.PI);
				}
			}
			
		}
		
		public var m_world:b2World;
		public var m_iterations:int = 10;
		public var m_timeStep:Number = 1.0/30.0;
		
	}

}