﻿package {
	
	import com.sounds.Music;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;
	import flash.utils.Timer;
	import flash.ui.Keyboard;

	// Classes used in this example
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import com.*;
	import com.Spike;
	import com.ContactListener;
	import com.FPSCounter;
	import com.GameOver;
	
	import Box2D.Dynamics.Joints.b2DistanceJoint;	import com.Ground;
	import Box2D.Dynamics.Joints.b2DistanceJointDef;	
	
	import gs.TweenLite;
	
	public class GameDoc extends Sprite{
		// const
		public static const STAGE_SIZE_X = 700;
		public static const STAGE_SIZE_Y = 400;
		// stage instances
		public var fps_txt:TextField;
		public var timeBar_mc:MovieClip;
		public var title_mc:MovieClip;
		
		public var c1_mc:MovieClip;
		public var c2_mc:MovieClip;
		public var c3_mc:MovieClip;
		public var c4_mc:MovieClip;
		public var c5_mc:MovieClip;
		public var c6_mc:MovieClip;
		
		public var fade_mc:*;
		public var ripple_mc:MovieClip;

		private var sf:Number = 30.0; //the size factor to multiple the visual representations of the objects
		private var player:Player;
		private var goal:Goal;
		private var level:Number = 0;
		private var isDebugOn:Boolean = false;
		
		//private var impulseTimer:Timer = new Timer(100);
		
		public function GameDoc(){

			fps_txt.visible = false;

			// Add event for main loop
			addEventListener(Event.ENTER_FRAME, Update, false, 0, true);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, on_keyDown);

			
			// Creat world AABB
			var worldAABB:b2AABB = new b2AABB();
			worldAABB.lowerBound.Set(-100.0, -100.0);
			worldAABB.upperBound.Set(100.0, 100.0);
			
			// Define the gravity vector
			var gravity:b2Vec2 = new b2Vec2(0.0, 0.0);
			
			// Allow bodies to sleep
			var doSleep:Boolean = true;
			
			// Construct a world object
			world = new b2World(worldAABB, gravity, doSleep);
			

			// Add some objects
			new Ground(stage, world, sf );
			
			stage.addEventListener(MouseEvent.MOUSE_MOVE, ripple);
//			stage.addEventListener(MouseEvent.CLICK, ripple);
			
			//create player object
			player = new Player(stage,world,sf);
			advanceStage();	// Go to stage 1;
			
			//bg music
			new Music();
			
			//time limit
			TweenLite.to(timeBar_mc, 60 * 5, { width:stage.stageWidth, onComplete:gameOver } );
			
			//remove title screen
			TweenLite.to(title_mc, 10, { alpha:0 } );
			
			//attack fade
			fade_mc = this.addChild(new GameOver());
			
		}
		
		
		public function advanceStage() {
			level++;
			var funcName = "stage" + level
			if (funcName in this) {
				this[funcName]();
				//show icon
				if(level>1){
					TweenLite.to(this["c" + (level - 1) + "_mc"], .5, { alpha:1 } );
				}
				//this["c" + (level - 1) + "_mc"].alpha = 1;
			} else {
				trace('no more levels to go to.');
				gameOver();
			}
		}
		
		
		//level one definition
		public function stage1() {
			goal = new Goal(stage,world,sf,this);
		}
		
		public function stage2() {
			goal = new Goal(stage,world,sf,this);
			
			createCluster(player, 3, 0);
		}

		public function stage3() {
			goal = new Goal(stage,world,sf,this);
			
			createCluster(player, 3, 0);
		
			new Spike(stage, world, sf );
		}

		public function stage4() {
			trace('stage 4');
			goal = new Goal(stage,world,sf,this);
			
			createCluster(player, 3, 0);

			new Spike(stage, world, sf );
		}

		public function stage5() {
			trace('stage 5');
			goal = new Goal(stage,world,sf,this);
			
			createCluster(player, 3, 0);
// Clustering the goal is not working yet. -ww
//			createCluster(goal, 4);

			new Spike(stage, world, sf );
		}

		public function stage6() {
			trace('stage 6');
			goal = new Goal(stage,world,sf,this);
			
			createCluster(player, 3, 2);
// Clustering the goal is not working yet. -ww
//			createCluster(goal, 4);

			new Spike(stage, world, sf );
		}

		

		public function resetBoard() {
			//after level is completed
			
			//remove goal object
			
			//remove all bubble objects
		}
		
		private function createCluster(entity, numBubbles, secondLayer=0) {
			var br = 20.0;
			for (var d = 0; d < 360; d += 360 / numBubbles) {
				
				var bx = br * Math.cos(d * Math.PI / 180.0) + entity.x;
				var by = br * Math.sin(d * Math.PI / 180.0) + entity.y;
//				trace("bx: " + bx);
//				trace("by: " + by);
				var bub:Bubble = new Bubble(stage, world, sf, bx, by);
				
				var djd:b2DistanceJointDef = new b2DistanceJointDef();
			
				djd.Initialize(entity.body, bub.body, entity.body.GetPosition(), bub.body.GetPosition() );
				//trace("bub xpos = " + bub.body.GetPosition().x);
				//trace("bub ypos = "+bub.body.GetPosition().y);
				bub.setJoint(world.CreateJoint(djd));
				
				for (var e; e < 360; e += 360 / secondLayer) {
					var bx = br * Math.cos(d * Math.PI / 180.0) + bub.x;
					var by = br * Math.sin(d * Math.PI / 180.0) + bub.y;
	//				trace("bx: " + bx);
	//				trace("by: " + by);
					var bub2:Bubble = new Bubble(stage, world, sf, bx, by);
					
					var djd:b2DistanceJointDef = new b2DistanceJointDef();
				
					djd.Initialize(bub.body, bub2.body, bub.body.GetPosition(), bub2.body.GetPosition() );
					//trace("bub2 xpos = " + bub2.body.GetPosition().x);
					//trace("bub2 ypos = "+bub2.body.GetPosition().y);
					bub2.setJoint(world.CreateJoint(djd));

				}
			}
		}
		
		public function ripple(e:Event) {
			//animate			
			const RIPPLE_FACTOR = 200.0;	// MOVING ripple
			ripple_mc.x = stage.mouseX;			
			ripple_mc.y = stage.mouseY;			
			ripple_mc.play();			
			world.Step(m_timeStep, m_iterations);
			var fX:Number = 1;
			var fY:Number = 1;
			// Go through body list and update sprite positions/rotations
			for (var bb:b2Body = world.m_bodyList; bb; bb = bb.m_next){
				if (bb.m_userData is Sprite){
					var dist = Math.sqrt( Math.pow(bb.m_userData.x - stage.mouseX,2)+Math.pow(bb.m_userData.y - stage.mouseY,2))
					bb.ApplyForce(
						new b2Vec2((bb.m_userData.x - stage.mouseX)/Math.pow(dist,2)*RIPPLE_FACTOR,  (bb.m_userData.y - stage.mouseY)/Math.pow(dist,2)*RIPPLE_FACTOR), 
						new b2Vec2( bb.m_userData.x/sf, bb.m_userData.y/sf));
				}
			}
		}
		
		public function Update(e:Event):void{
			if (isDebugOn){
				fps_txt.text = FPSCounter.update();
			}
			
			world.Step(m_timeStep, m_iterations);
			
			// Go through body list and update sprite positions/rotations
			for (var bb:b2Body = world.m_bodyList; bb; bb = bb.m_next){
				if (bb.m_userData is Sprite){
					bb.m_userData.x = bb.GetPosition().x * sf;
					bb.m_userData.y = bb.GetPosition().y * sf;
					bb.m_userData.rotation = bb.GetAngle() * (180/Math.PI);
				}
			}
			ContactListener.update()
			
			//test for collision of player and goal
			
		}
		
		public var world:b2World;
		public var m_iterations:int = 10;
		public var m_timeStep:Number = 1.0/30.0;
		
		function on_keyDown(event:KeyboardEvent):void {
//			trace('keyCode='+event.keyCode);
			const KEY_D = 68;
            if (event.keyCode == KEY_D){
				activateDebug();
			}
			const KEY_E = 69;
            if (event.keyCode == KEY_E){
				advanceStage();
			}

        }
		
		function activateDebug(){
			// You can't turn off debugging, since box2d doesn't clear its debugging lines.
			if (isDebugOn) return;
			isDebugOn = true;
			trace('Debug is On');
			
			// FPS
			fps_txt.visible = true;
			
			// Physics debugging lines.
			var dbgDraw:b2DebugDraw = new b2DebugDraw();
			
			var dbgSprite:Sprite = new Sprite();
			addChild(dbgSprite);
			dbgDraw.m_sprite = dbgSprite;
			dbgDraw.m_drawScale = 30.0;
			dbgDraw.m_fillAlpha = 0.0;
			dbgDraw.m_alpha = 0.3;
			dbgDraw.m_lineThickness = 1.0;
			dbgDraw.m_drawFlags = 0xFFFFFFFF;
			world.SetDebugDraw(dbgDraw);
		}
		
		function gameOver() {
			
			//go to end screen
			fade_mc.play();
			
			// Go through body list and update sprite positions/rotations
			for (var bb:b2Body = world.m_bodyList; bb; bb = bb.m_next){
				if (bb.m_userData is Sprite){
					TweenLite.to(bb.m_userData, 3, {alpha:0});
				}
			}
			ContactListener.update()
			
			//test for collision of player and goal
		}

	}
	

}