﻿package com{
	
	/**
	 * ...
	 * @author ...
	 */
	// Classes used in this example
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.b2Joint;
	import com.sounds.Glom;
	import com.sounds.Pop;
	import flash.display.MovieClip;
	import flash.display.Stage;
	import Box2D.Dynamics.Joints.b2DistanceJointDef;
	
	import com.BaseEntity;
	
	public class Bubble extends BaseEntity
	{
		private var sf:Number;
		private var bodyDef:b2BodyDef = new b2BodyDef();
		private var circleDef:b2CircleDef = new b2CircleDef();
		public var body:b2Body;
		private var world:b2World;
		private var stageRef:Stage;
		private var joint:b2Joint;
		
		private var joints:Array;
		
		public function Bubble(s:Stage, w:b2World, num:Number, xPos:Number = 0, yPos:Number = 0) {
			world = w;
			sf = num;
			stageRef = s;
			
			//make a new bubble, add it to the world
			bodyDef.position.x = xPos/sf;
			bodyDef.position.y = yPos/sf;

			var radius:Number = 10;

			this.width = radius * 2; 
			this.height = radius * 2; 

			// Circle
			circleDef.radius = radius/sf;
			circleDef.density = 1.0;
			circleDef.friction = 1;
			circleDef.restitution = 0.2;
			circleDef.userData = this;
			//body
			bodyDef.userData = this;
			//damping
			bodyDef.linearDamping = 1.01;
			bodyDef.angularDamping = 1.01;

			body = world.CreateBody(bodyDef);
			body.CreateShape(circleDef);
			body.SetMassFromShapes();
			//add to stage
			stageRef.addChild(this);
		}

		override public function on_collision( otherEntity: MovieClip) {
		//	trace("BUBBLE COLLISION DETECTED");
			//if entity type is SPIKE
			if (otherEntity is Spike) {
				//trace("BUBBLE HAS COLLIDED WITH SPIKE");
				//break joint
				if(joint){
					world.DestroyJoint(joint);
					joint = null;
					new Pop();
				}

				/*for each (var joint in joints) {
					world.DestroyJoint(joint);
				}*/
			}
			else if (otherEntity is Bubble) {
				
				if(!joint){
					
				//create a joint between them
				var djd:b2DistanceJointDef = new b2DistanceJointDef();
			
				djd.Initialize(this.body, otherEntity.body, this.body.GetPosition(), otherEntity.body.GetPosition() );
				setJoint(world.CreateJoint(djd));
				new Glom();				}
				
				//create a joint between them
				/*var djd:b2DistanceJointDef = new b2DistanceJointDef();
			
				djd.Initialize(this.body, otherEntity.body, this.body.GetPosition(), otherEntity.body.GetPosition() );
				setJoint(world.CreateJoint(djd));*/
			}
		}
		
		//G&S
		public function setJoint(ref:b2Joint) {
			joint = ref;
		}

		public function addJoint(ref:b2Joint) {
			joints.push(ref);
		}
	}
	
}