﻿package com
{
	
	/**
	 * ...
	 * @author ...
	 */
	// Classes used in this example
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import com.sounds.Mate;
	import flash.display.MovieClip;
	import flash.display.Stage;
	
	import com.BaseEntity;
	import GameDoc;
	
	public class Goal extends BaseEntity
	{
		public var body:b2Body;

		private var sf:Number;
		private var bodyDef:b2BodyDef = new b2BodyDef();
		private var circleDef:b2CircleDef = new b2CircleDef();
		private var world:b2World;
		private var stageRef:Stage;
		private var gameDoc:GameDoc;
		
		public function Goal(s:Stage, w:b2World, num:Number, gd:GameDoc) {
			world = w;
			sf = num;
			stageRef = s;
			gameDoc = gd;
			
			//make a new bubble, add it to the world
			bodyDef.position.x = (Math.random() * GameDoc.STAGE_SIZE_X + 5)/sf;
			bodyDef.position.y = (Math.random() * GameDoc.STAGE_SIZE_Y)/sf;

			var radius:Number = 15;	// in Flash coordinates

			this.width = radius * 2; 
			this.height = radius * 2; 
			// Circle
			circleDef.radius = radius/sf;
			circleDef.density = 1.0;
			circleDef.friction = 1;
			circleDef.restitution = 0.2;
			circleDef.userData = this;
			//body
			bodyDef.userData = this;
			//damping
			bodyDef.linearDamping = 1.01;
			bodyDef.angularDamping = 1.01;

			body = world.CreateBody(bodyDef);
			body.CreateShape(circleDef);
			body.SetMassFromShapes();
			//add to stage
			stageRef.addChild(this);
		}
		
		override public function on_collision( otherEntity: MovieClip){
			if (otherEntity is Player){
//				trace('Goal: Goal touched. Go to next level.');
				if (stageRef){
					stageRef.removeChild( this );
					stageRef = null;
					world.DestroyBody( body );
					gameDoc.advanceStage();
					//snd
					new Mate();		
					//animate
					otherEntity.play();
					}
			}
		}

	}
	
}