﻿/*
	Ground.as
*/

package com {
	
	import flash.display.Stage;
//	import flash.display.Sprite;
//	import flash.events.Event;
//	import flash.events.MouseEvent;
	// Classes used in this example
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;	
	
	import GameDoc;

	public class Ground {
		// constants
		const STAGE_SIZE_X = GameDoc.STAGE_SIZE_X;
		const STAGE_SIZE_Y = GameDoc.STAGE_SIZE_Y;
		
		// vars
		var stageRef:Stage;
		var world:b2World;
		var sf:Number;
		
		// Constructor
		public function Ground(s:Stage, wld:b2World, the_sf:Number){
			stageRef = s;
			world = wld;
			sf = the_sf;
			
			// Vars used to create bodies
			var body:b2Body;
			var bodyDef:b2BodyDef;
			var boxDef:b2PolygonDef;

			const LENGTH = STAGE_SIZE_X;
			const THICKNESS = 100;

			// Add ground
			makeGround( STAGE_SIZE_X/2, STAGE_SIZE_Y+(THICKNESS/2),
				STAGE_SIZE_X, THICKNESS );	// bottom
			makeGround( STAGE_SIZE_X/2, -(THICKNESS/2),
				STAGE_SIZE_X, THICKNESS );	// top

			makeGround( -(THICKNESS/2), STAGE_SIZE_Y/2,
				THICKNESS, STAGE_SIZE_Y );	// left
			makeGround( STAGE_SIZE_X+(THICKNESS/2), STAGE_SIZE_Y/2,
				THICKNESS, STAGE_SIZE_Y );	// right

		}
		
		/**
			Create edge blocks for the side of the screen.
			x,y,width,height are in Flash coordinates
		**/
		function makeGround( x,y, width, height ){
			var body:b2Body;
			var bodyDef:b2BodyDef;
			var boxDef:b2PolygonDef;

			// Add ground
			var ground = new PhysGround();
			bodyDef = new b2BodyDef();
			bodyDef.position.Set(x/sf, y/sf);
			boxDef = new b2PolygonDef();
			
			// Set size
			boxDef.SetAsBox(width/sf/2, height/sf/2);
			ground.width = width; 
			ground.height = height; 

			boxDef.friction = 0.3;
			boxDef.density = 0; // static bodies require zero density
			boxDef.userData = ground;
			// Add sprite to body userData
			bodyDef.userData = ground;
			stageRef.addChild(ground);
			
			body = world.CreateBody(bodyDef);
			body.CreateShape(boxDef);
			body.SetMassFromShapes();		
		}
	}
}