﻿/**
	Spike.as
	
	Spike is responsible for:
		- Moving around
		
**/

package com {
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.*;

	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	
	import com.BaseEntity;
	import GameDoc;

	public class Spike extends BaseEntity {
		// const
		// var
		private var world:b2World;
		private var sf:Number;
		
		private var body:b2Body;
		private var bodyDef: b2BodyDef;
		private var circleDef: b2CircleDef;
		
		// Constructor
		public function Spike(s:Stage, w:b2World, num:Number) {
			world = w;
			sf = num;

			var radius:Number = 18;		// in Flash coordinates
			// Create a physics model for this thing.
			bodyDef = new b2BodyDef();
			bodyDef.position.x = (Math.random() * GameDoc.STAGE_SIZE_X + 5)/sf;
			bodyDef.position.y = (Math.random() * GameDoc.STAGE_SIZE_Y)/sf;
			bodyDef.userData = this;
			bodyDef.userData.width = radius * 2; 
			bodyDef.userData.height = radius * 2; 
			
			circleDef = new b2CircleDef();
			circleDef.radius = radius/sf;
			circleDef.density = 1.0;
			circleDef.friction = 0.5;
			circleDef.restitution = 0.2;
			circleDef.userData = this;

		
			
			body = world.CreateBody(bodyDef);
			body.CreateShape(circleDef);
			body.SetMassFromShapes();

			s.addChild(this);		
			world.SetContactListener(ContactListener.singleton());
		}
		
	}
}